/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 14.10.2009
Author  : Name
Company : Organisation
Comments: 


Chip type               : AT90USB1287
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 2048
*****************************************************/

#include <90usb1287.h>
#include <delay.h>


//   USB 

// USBCON
#define USBE    7
#define OTGPADE 4
#define FRZCLK  5
#define HOST    6
#define VBUSTE  0
// UHWCON
#define UVCONE  4
// UDCONE 
#define DETACH  0
// OTGCON
#define VBUSHWC 2
// UHIEN
#define DDISCE  1
// UPCONX 
#define PEN 0
#define INMODE 5
#define PFREEZE 6
// UPCFG1X
#define ALLOC 1
// UPSTAX
#define CFGOK 8
// UHINT
#define DCONNI 0
// UPINTX
#define RXINI 0 
#define TXSTPI 3
#define FIFOCON 7
// UHCON
#define SOFEN 0
// UPIENX
#define TXSTPE 3
#define RXINE 0
// PLLCSR
#define PLLP2 4
#define PLLP1 3
#define PLLP0 2
#define PLLE  1
#define PLOCK 0



#define PLLx03                  ((1<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define Start_pll(clockfactor)  (PLLCSR = ( clockfactor  | (1<<PLLE)  ))
#define Pll_start_auto()         Start_pll(PLLx03)
#define Wait_pll_ready()         while (!(PLLCSR & (1<<PLOCK)))

//#define Usb_select_host()             


unsigned char a;
unsigned char rx_buf[64];
unsigned int count;
unsigned char usb_setup[8];
unsigned int index;
/*unsigned char host_config_pipe(unsigned char config0, unsigned char config1)
{
    Host_enable_pipe();
    UPCFG0X = config0;
    UPCFG1X = config1;
    Host_allocate_memory();
    return (Is_pipe_configured());
} */


// USB general interrupt service routine
interrupt [USB_GENERAL] void usb_general_isr(void)
{
if (USBINT & 1)
   {
    a=1;
   }
if (USBINT & 2)
   {
   // ID Transition interrupt
   // Place your code here
    a=2;
   }
USBINT=0; // Clear the interrupt flags
if (OTGINT & 1)
   {
   // SRP interrupt
   // Place your code here
      a=3;
   }
if (OTGINT & 2)
   {
   // V-Bus Error interrupt
   // Place your code here
       a=4;
   }
if (OTGINT & 4)
   {
   // B-Connection Error interrupt
   // Place your code here
       a=5;
   }
if (OTGINT & 8)
   {
   // Role Exchange interrupt
   // Place your code here
       a=6;
   }
if (OTGINT & 0x10)
   {
   // HNP Error interrupt
   // Place your code here
      a=7;
   }
if (OTGINT & 0x20)
   {
   // Suspend Time-out Error interrupt
   // Place your code here
      a=8;
   }
OTGINT=0; // Clear the interrupt flags
}

// USB Host/Pipe interrupt service routine
interrupt [USB_ENDPOINT_PIPE] void usb_host_pipe_isr(void)
{
if (UHINT & 1)
   {
   // Device Connection interrupt
   // Place your code here
      a=9;
   }
if (UHINT & 2)
   {
   // Device Disconnection interrupt
   // Place your code here
       a=10;
   }
if (UHINT & 4)
   {
   // USB Reset Sent interrupt
   // Place your code here
        a=11;
   }
if (UHINT & 8)
   {
   // Downstream Resume Sent interrupt
   // Place your code here
       a=12;
       
   }
if (UHINT & 0x10)
   {
   // Upstream Resume Received interrupt
   // Place your code here
        a=13;
   }
if (UHINT & 0x20)
   {
   // Host Start Of Frame interrupt
   // Place your code here
       a=14;
   }
if (UHINT & 0x40)
   {
   // Host Wake-up interrupt
   // Place your code here
       a=15;
   }
UHINT=0; // Clear the interrupt flags
if (UPINTX & 1)
   {
   // IN Data Received interrupt
   // Place your code here
         a=16; 
     count = (UPBCHX<<8)|UPBCLX;
     for (index=0; index<count;index++)
       {
         rx_buf[index]=UPDATX;
       } 
     UPINTX&= (~(1<<RXINI));
   }
if (UPINTX & 2)
   {
   // STALL Received/Isochronous CRC Error interrupt
   // Place your code here
       a=17;
   }
if (UPINTX & 4)
   {
   // OUT Bank Ready interrupt
   // Place your code here
       a=18;
   }
if (UPINTX & 8)
   {
   // SETUP Bank Ready interrupt
   // Place your code here
   UPCONX&=(~(1<<INMODE)); // 0
   UPINRQX=0x00;           //  1 
   UPCONX&=(~(1<<PFREEZE)); //  
   UPINTX&=(~(1<<TXSTPI));// -   TXSTPI
   }
if (UPINTX & 0x10)
   {
   // Pipe Error interrupt
   // Place your code here
       a=20;
   }
if (UPINTX & 0x40)
   {
   // NAK Handshake Received interrupt
   // Place your code here
       a=21;
   }
//UPINTX&=0x5F; // Clear the interrupt flags
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTE=0x00;
DDRE=0x00;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTF=0x00;
DDRF=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;
// PCINT0 interrupt: Off
// PCINT1 interrupt: Off
// PCINT2 interrupt: Off
// PCINT3 interrupt: Off
// PCINT4 interrupt: Off
// PCINT5 interrupt: Off
// PCINT6 interrupt: Off
// PCINT7 interrupt: Off
PCMSK0=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;
// Timer/Counter 3 Interrupt(s) initialization
TIMSK3=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

Pll_start_auto();
Wait_pll_ready();

//   usb MAX4789EUK
DDRE=0x80; 
PORTE.7=1; 
// USB 
USBCON = ~((1<<USBE)|(1<<OTGPADE)); // USB
USBCON = ((1<<USBE)|(1<<OTGPADE));  // USB
USBCON  &= ~(1<<FRZCLK);            //  USB
UDCON   &= ~(1<<DETACH);            //  DETACH( )
UHWCON &= ~(1<<UVCONE);             //   UVCON
USBCON  |=  (1<<HOST);              // -
//OTGCON  &=  ~(1<<VBUSHWC);        //    UVCON
OTGCON  |=  (1<<VBUSHWC);           //    UVCON
USBCON|=(1<<VBUSTE);                //     VBus    
USBINT=0x00;                       //  ,     Vbus  
UHIEN=0x03;                        //       
UHINT=0x00;

// 
UPRST=0x01;
UPRST=0x00;   //  0
UPNUM=0x00;   //  0
UPCONX|=(1<<PEN);
UPCFG0X=0x00; //  - ,  - SETUP,  - 0
UPCFG1X=0x00; // - 8-100,   - 1.
UPCFG1X |= (1<<ALLOC); //  
while ((UPSTAX&0x80)!=0x80); //   
//UHCON|= (1<<SOFEN); //  SOF
UPIENX = ((1<<TXSTPE)|(1<<RXINE)); //     SETUP     
UPINTX &= (~(1<<TXSTPI)); //  
// Global enable interrupts
#asm("sei")
usb_setup[0]=0x80;
usb_setup[1]=0x06; 
usb_setup[2]=0x00;
usb_setup[3]=0x01;
usb_setup[4]=0x00;
usb_setup[5]=0x00;
usb_setup[6]=0x08;
usb_setup[7]=0x00;  
while (1)
      {
      // Place your code here
      
       if (a==1) //  
         {
           a=0;
           UPNUM=0x00; // setup  
           UECONX=0x01;
           for (index=0;index<8;index++) //   FIFO
             UPDATX=usb_setup[index];
           UPINTX&= (~(1<<FIFOCON)); //  FIFOCON -   
          // UPCONX&=0xBF;
         }

      };
}
